#ifndef ACTOR_H
#define ACTOR_H

#include <memory>
#include <list>
#include <set>

class Location;
class Item;

class Actor
{
public:
    explicit Actor();
    virtual ~Actor() = 0;

    virtual void commitAction() = 0;
    virtual void moveToLocation(const std::shared_ptr<Location>& location) = 0;
    virtual bool isLocationVisited(const std::shared_ptr<Location>& location) const = 0;
    virtual void giveItem(const std::shared_ptr<Item>& item) = 0;
    virtual void useItem(const std::shared_ptr<Item>& item) = 0;
    virtual bool hasItem(const std::shared_ptr<Item>& item) const = 0;

protected:
    std::shared_ptr<Location> _current_location;
    std::list<std::shared_ptr<Item>> _inventory;
    std::set<std::shared_ptr<Location>> _visited_locations;
};

#endif // ACTOR_H
